floor,ceil = math.floor, math.ceil
cos,sin,tan = math.cos, math.sin, math.tan
lg,ln,exp = math.log10, math.log, math.exp
pi = math.pi
xor = function(a,b) return (a or b) and not (a and b) end
frac = function(a) local x,y = math.modf(a); return y end
int = function(a) local x,y = math.modf(a); return x end
rand = math.random

local common_numpad = {
	{'7', '8', '9'},
	{'4', '5', '6'},
	{'1', '2', '3'},
	{'e', '0', '.'},
}

local common_operationspad = {
	{'^', '+', '%', '~', 'floor()', 'asin()', 'acos()', 'atan()',},
	{'*', '=', '/', '<', 'cos()', 'sin()', '$return', 'tan()',},
	{'(', '-', ')', '>', 'ceil()', 'ln()', 'exp()', 'lg()',},
	{'and', 'or', 'not', 'xor()', 'frac()', 'int()', 'rand()', 'pi'},
}

local common_misc = {
	{'n', 'function() return  end;', 'm'},
	{'local ', ';', ','},
	{'i', 'j', 'k'},
	{'x', 'y', 'z'},
}

local common_panel_keys = {}
for i = 1, 4 do
	common_panel_keys[i] = {}
end

for i = 1, 4 do
	for j = 1,3 do
		common_panel_keys[i][j] = common_numpad[i][j]
		common_panel_keys[i][j+17] = common_misc[i][j]
	end

	for j = 1,8 do
		common_panel_keys[i][j+6] = common_operationspad[i][j]
	end
end

common_panel_keys[2][5] = '$clear'
common_panel_keys[2][16] = '$clear'

local labels = {
	A = {2, 2},
	B = {2, 8},
	X = {2, 13},
	Y = {2, 19},
}

common_panel_keys.labels = labels

return common_panel_keys
