local keyboard_numpad = {
	{'7', '8', '9', '?',},
	{'4', '5', '6', '\t',},
	{'1', '2', '3', '$shift',},
	{'e', '0', '.', '$caps',},
}

local keyboard_keypad = {
	{'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p',},
	{'a', 's', 'd', 'f', 'g', 'h', 'j', '$return', 'k', 'l',},
	{'z', 'x', 'c', 'v', 'b', 'n', 'm', '.', '<', '>',},
	{'!', '@', '#', '$$', '%', '^', '&', '*', '_', '|',},
}

local keyboard_addpad = {
	{'\\','[', '-', ']',},
	{'/', '=', ';', ',',},
	{'~', '{', '+', '}',},
	{'`', "'", '"', ':'},
}

local keyboard_panel_keys = {}
for i = 1, 4 do
	keyboard_panel_keys[i] = {}
end

for i = 1, 4 do
	for j = 1,4 do
		keyboard_panel_keys[i][j] = keyboard_numpad[i][j]
		keyboard_panel_keys[i][j+16] = keyboard_addpad[i][j]
	end

	for j = 1,10 do
		keyboard_panel_keys[i][j+5] = keyboard_keypad[i][j]
	end
end

keyboard_panel_keys[2][5] = '$clear'
keyboard_panel_keys[2][16] = '$clear'

local labels = {
	A = {2, 2},
	B = {2, 8},
	X = {2, 13},
	Y = {2, 19},
}

keyboard_panel_keys.labels = labels

keyboard_panel_keys.leds = {
	caps = {4, 5}
}

return keyboard_panel_keys
