require 'class'

local isDown = love.keyboard.isDown

local exit = os.exit

local dingoo_mapping = {
	lctrl = 'A',
	lalt = 'B',
	[' '] = 'X',
	lshift = 'Y',
	tab = 'L',
	backspace = 'R',
	['return'] = 'start',
	escape = 'select',
	pause = 'power',
}

local ABXY = {A = true, B = true, X = true, Y = true}
local directions = {left = true, right = true, up = true, down = true}

LoveDingooController = class()

LoveDingooController.load = function(self)
end

LoveDingooController.update = function(self, dt, model)
	if isDown('lctrl') or isDown('lalt') or isDown(' ') or isDown('lshift') then
		model.focus = 'pad'
	elseif isDown('escape') then
		model.focus = 'tabs'
	else
		model.focus = 'textbox'
	end
end

LoveDingooController.keypressed = function(self, key, unicode, model)
	local key = dingoo_mapping[key] or key

	if ABXY[key] then
		model:jump(key)
	elseif directions[key] then
		model:move(key)
	elseif key == 'L' then
		if model.focus == 'textbox' then
			model:processCommand('$backspace')
		else
			model:move('left')
		end
	elseif key == 'R' then
		if model.focus == 'textbox' then
			model:processCommand('$space')
		else
			model:move('right')
		end
	end
end

LoveDingooController.keyreleased = function(self, key, unicode, model)
	local key = dingoo_mapping[key] or key

	if ABXY[key] then
		model:processSelection()
--~ 		model.select = false
	end
end
