require 'class'
require 'model'
require 'loveview'
require 'lovedingoocontroller'

local model = Model()
local view = LoveView()
local controller = LoveDingooController()

love.load = function()
	model:load()
	view:load()
	controller:load()
end

love.update = function(dt)
	controller:update(dt, model)
	model:update(dt)
	view:update(dt)
end

love.draw = function()
	view:draw(model)
end

love.keypressed = function(key, unicode)
	controller:keypressed(key, unicode, model)
end

love.keyreleased = function(key, unicode)
	controller:keyreleased(key, unicode, model)
end
